<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckAnimnumber extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_ANIMNUMBER';

	private $type = 'animnumber';

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	public function callAssets() {
		// load the script in the page in admin and front
		JHtml::_('jquery.framework', true);
		$doc = JFactory::getDocument();
		PagebuilderckFrontHelper::addStylesheet(JUri::root(true) . '/plugins/pagebuilderck/animnumber/assets/animnumber.css');
		$doc->addScript(JUri::root(true) . '/plugins/pagebuilderck/animnumber/assets/animnumber.js');
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'other';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/animnumber/assets/images/animatednumber.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentAnimnumber() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>" onshow="pbckAnimnumberInit(jQuery(this).attr('id'));">
			<div class="tab_animnumber ckprops" fieldslist="bloccolor,blocfontsize" bloccolor="#20B2AA" blocfontsize="40"></div>
			<div class="ckstyle">
			<style>
				#<?php echo $id; ?> > div.inner {
					color: #20B2AA;
					font-size: 40px;
				}
			</style>
			</div>
			<div class="animnumberck inner">
				<div class="animnumberckvalue"></div>
				<div class="animnumberckpie"></div>
			</div>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsAnimnumber() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/animnumber/layouts/edit_animnumber.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemAnimnumber($item) {
		$this->callAssets();
		$html = $item->innertext;

		return $html;
	}
}