<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckButton extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_BUTTON';

	private $type = 'button';

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'text';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/button/assets/images/button.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentButton() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>">
			<div class="tab_blocstyles ckprops" linktext="Click me" blocbackgroundcolorstart="#f2f2f2" bloccolor="#555555" blocfontsize="14" blocpaddingtop="8" blocpaddingright="20" blocpaddingbottom="8" blocpaddingleft="20" blocmargins="20" blocborderradius="3" fieldslist="blocbackgroundcolorstart,bloccolor,blocfontsize,blocpaddingtop,blocpaddingright,blocpaddingbottom,blocpaddingleft,blocmargins,blocborderradius"></div>
			<div class="tab_blochoverstyles ckprops" linktext="Click me" blochoverbackgroundcolorstart="#dedede" blochoverfontunderline="nodecoration" fieldslist="blochoverbackgroundcolorstart,blochoverfontunderline"></div>
			<div class="tab_button ckprops" linktext="Click me" fieldslist="linktext"></div>
			<div class="ckstyle">
			<style>
				#<?php echo $id; ?> > .inner {
					background: #f2f2f2;
					-moz-border-radius: 3px;
					-o-border-radius: 3px;
					-webkit-border-radius: 3px;
					border-radius: 3px;
					color: #555555;
					padding-top: 8px;
					padding-right: 20px;
					padding-bottom: 8px;
					padding-left: 20px;
					margin: 20px;
					font-size: 14px;
				}
				#<?php echo $id; ?> > .inner:hover {
					background: #dedede;
					text-decoration: none;
				}
			</style>
			</div>
			<a class="buttonck iconck inner" href="javascript:void(0)"><span class="buttontextck">Click me</span></a>
		</div>
		<?php
	}
/*
<div class="tab_blocstyles ckprops" blocbackgroundcolorstart="#ffffff" blocbackgroundpositionend="100" blocbackgroundcolorend="#d8d8d8" blocbackgrounddirection="topbottom" blocbackgroundimageattachment="scroll" blocbackgroundimagerepeat="no-repeat" blocbackgroundimagesize="auto" bloccolor="#555555" blocfontsize="13" blocpaddingtop="6" blocpaddingright="20" blocpaddingbottom="6" blocpaddingleft="20" blocborderradius="3" blocbordertopstyle="solid" blocborderrightstyle="solid" blocborderbottomstyle="solid" blocborderleftstyle="solid" blocborderscolor="#bbbbbb" blocborderssize="1" blocbordersstyle="solid" blocshadowcolor="#4d4d4d" blocshadowblur="2" blocshadowspread="-1" blocshadowoffsetv="2" blocshadowinset="0" fieldslist="blocbackgroundcolorstart,blocbackgroundpositionend,blocbackgroundcolorend,blocbackgrounddirection,blocbackgroundimageattachment,blocbackgroundimagerepeat,blocbackgroundimagesize,bloccolor,blocfontsize,blocalignementleft,blocalignementcenter,blocalignementright,blocalignementjustify,blocpaddingtop,blocpaddingright,blocpaddingbottom,blocpaddingleft,blocborderradius,blocbordertopstyle,blocborderrightstyle,blocborderbottomstyle,blocborderleftstyle,blocborderscolor,blocborderssize,blocbordersstyle,blocshadowcolor,blocshadowblur,blocshadowspread,blocshadowoffsetv,blocshadowinset"></div>
<div class="tab_button ckprops" blocfontsize="40" bloccolor="#20B2AA" fieldslist="buttonalignementleft,buttonalignementcenter,buttonalignementright,uselightbox,lightboxalbum" uselightbox="0" lightboxalbum="0"></div>*/
	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsButton() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/button/layouts/edit_button.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemButton($item) {
		$html = $item->innertext;

		return $html;
	}
}