<?php
/**
 * @name		Page Builder CK
 * @package		com_pagebuilderck
 * @copyright	Copyright (C) 2020. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - https://www.template-creator.com - https://www.joomlack.fr
 */

defined('_JEXEC') or die;

$input = JFactory::getApplication()->input;
?>
<div id="elementscontainer">
	<div class="menulink" tab="tab_map"><?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_EDITION'); ?></div>
	<div class="tab menustyles ckproperty ckoption" id="tab_map">
		<div class="menupanetitle"><?php echo JText::_('CK_ADDRESS'); ?></div>
		<div>
			<div class="ckoption-field" style="width:auto">
				<input class="inputbox" type="text" value="" name="address" id="address" style="width:275px;" />
			</div>
			<div style="text-align:center;">-- <?php echo JText::_('CK_OR'); ?> --</div>
			<div style="display:flex;">
				<div style="width:50%;">
					<div class="menupanetitle"><?php echo JText::_('CK_LATITUDE'); ?></div>
					<div class="ckoption-field" style="width:auto">
						<input class="inputbox" type="text" value="" name="latitude" id="latitude" style="width:135px;" />
					</div>
				</div>
				<div style="width:50%;">
					<div class="menupanetitle"><?php echo JText::_('CK_LONGITUDE'); ?></div>
					<div class="ckoption-field" style="width:auto">
						<input class="inputbox" type="text" value="" name="longitude" id="longitude" style="width:135px;" />
					</div>
				</div>
			</div>
		</div>
		<hr />
		<div class="ckoption">
			<span class="ckoption-label">
				<?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_MAPTYPE'); ?>
			</span>
			<span class="ckoption-field ckbutton-group">
				<select class="inputbox" type="list" value="" name="maptype" id="maptype" onchange="ckUpdateMapPreview()">
					<option value="m"><?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_ROADMAP'); ?></option>
					<option value="k"><?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_SATELLITE'); ?></option>
					<option value="h"><?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_HYBRID'); ?></option>
					<option value="p"><?php echo JText::_('PLG_PAGEBUILDERCK_GOOGLEMAPLIGHT_TERRAIN'); ?></option>
				</select>
			</span>
		</div>
		<div class="ckoption">
				<span class="ckoption-label">
					<?php echo JText::_('CK_ZOOM'); ?>
					<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>magnifier.png" width="15" height="15" align="top" />
				</span>
				<span class="ckoption-field ckbutton-group">
					<input class="inputbox" type="text" name="mapzoom" id="mapzoom" value="8" onchange="ckUpdateMapPreview()" />
				</span>
			</div>
		<div class="menupanetitle"><?php echo JText::_('CK_DIMENSIONS'); ?></div>
		<div class="ckoption">
			<span class="ckoption-label">
				<?php echo JText::_('CK_WIDTH'); ?>
				<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>width.png" width="15" height="15" align="top" />
			</span>
			<span class="ckoption-field ckbutton-group">
				<input class="inputbox" type="text" name="mapwidth" id="mapwidth" value="100%" onchange="ckUpdateMapPreview()" />
			</span>
		</div>
		<div class="ckoption">
			<span class="ckoption-label">
				<?php echo JText::_('CK_HEIGHT'); ?>
				<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>height.png" width="15" height="15" align="top" />
			</span>
			<span class="ckoption-field ckbutton-group">
				<input class="inputbox" type="text" name="mapheight" id="mapheight" value="480px" onchange="ckUpdateMapPreview()" />
			</span>
		</div>
	</div>
	<div class="menulink" tab="tab_blocstyles"><?php echo JText::_('CK_STYLES'); ?></div>
	<div class="tab menustyles ckproperty" id="tab_blocstyles">
		<?php echo $this->menustyles->createBlocStyles('bloc', 'map', '') ?>
	</div>
</div>
<div class="clr"></div>
<script language="javascript" type="text/javascript">
var focus = $ck('.editfocus');
function ckLoadEditionPopup() {
	ckFillEditionPopup(focus.attr('id'));
}

function ckBeforeSaveEditionPopup() {
	ckUpdateMapPreview();
}


function ckUpdateMapPreview() {
	var address = $ck('#elementscontainer').find("#address").val();
	if (! address) {
		address = 'loc:' + $ck('#latitude').val() + '+' + $ck('#longitude').val();
	} else {
		address = encodeURIComponent(address);
	}
	var link = 'https://maps.google.com/maps?q=' + address + '&output=embed&iwloc=near';
	link += '&t=' + $ck('#maptype').val();
	var mapzoom = $ck('#mapzoom').val() ? $ck('#mapzoom').val() : '8';
	link += '&z=' + mapzoom;

	var mapw = $ck('#mapwidth').val() ? $ck('#mapwidth').val() : '';
	var maph = $ck('#mapheight').val() ? $ck('#mapheight').val() : '';

	focus.find('.googlemaplightck.inner').empty().append('<iframe src="' + link + '" frameborder="0" style="width: ' + mapw + '; height: ' + maph + '" />');
}

/*
 * Method automatically called in ckCloseEditionPopup() if exists (needed if you are using an editor !!)
 */
// function ckBeforeCloseEditionPopup() {
	// var textID = 'markercontent';
	// ckRemoveEditorOnTheFly(textID);
// }

// setup the map instance
// var geocoder, map, marker;
// var markers = [];

function ckInitializeMap() {
	geocoder = new google.maps.Geocoder();
	// var latlng = new google.maps.LatLng(48.856, 2.352);
	var latlng = {lat: 48.856, lng: 2.352};
	// var latlng = {lat: -25.363, lng: 131.044};
	var mapOptions = {
	  zoom: 8,
	  center: latlng,
	}
	map = new google.maps.Map(document.getElementById("mapck"), mapOptions);
	ckSetMarker();
}

// translate the address to the LatLong values
function ckSetMarker() {
	var address = $ck('#elementscontainer').find("#address").val();
	if (!address && !$ck('#latitude').val() && !$ck('#longitude').val() ) return;
	if ($ck('#latitude').val() && $ck('#longitude').val()) {
		var latlng = new google.maps.LatLng($ck('#latitude').val(), $ck('#longitude').val());
	}
	geoOpts = (latlng && !address) ? { 'location': latlng} : { 'address': address};
	geocoder.geocode( geoOpts, function(results, status) {
		if (status == google.maps.GeocoderStatus.OK) {
			$ck('#latitude').val(results[0].geometry.location.lat());
			$ck('#longitude').val(results[0].geometry.location.lng());
			map.setCenter(results[0].geometry.location);
			deleteMarkers();
			var marker = new google.maps.Marker({
				map: map,
				position: results[0].geometry.location,
				title: $ck('#markertitle').val()
			});
			var textID = 'markercontent';
			ckSaveEditorOnTheFly(textID);
			var content = $ck('#markercontent').val();
			content = ckEditorToContent(content);

			var infowindow = new google.maps.InfoWindow({
				content: content
			  });
			  
			marker.addListener($ck('#markershowon').val(), function() {
				infowindow.open(map, marker);
			});

			markers.push(marker);
		} else {
			alert("Geocode was not successful for the following reason: " + status);
		}
	});
}

// Sets the map on all markers in the array.
function ckSetMapOnAll(map) {
  for (var i = 0; i < markers.length; i++) {
    markers[i].setMap(map);
  }
}

// Removes the markers from the map, but keeps them in the array.
function ckClearMarkers() {
  ckSetMapOnAll(null);
}

// Shows any markers currently in the array.
function showMarkers() {
  ckSetMapOnAll(map);
}

// Deletes all markers in the array by removing references to them.
function deleteMarkers() {
  ckClearMarkers();
  markers = [];
}
  
function _ckUpdateMapPreview() {
	var mapzoom = $ck('#mapzoom').val() ? $ck('#mapzoom').val() : '8';
	map.setZoom(parseInt(mapzoom));
	// map.setMapTypeId($ck('#maptype').val());
	switch ($ck('#maptype').val()) {
		case 'google.maps.MapTypeId.ROADMAP' :
		default :
			map.setMapTypeId(google.maps.MapTypeId.ROADMAP);
			break;
		case 'google.maps.MapTypeId.SATELLITE' :
			map.setMapTypeId(google.maps.MapTypeId.SATELLITE);
			break;
		case 'google.maps.MapTypeId.HYBRID' :
			map.setMapTypeId(google.maps.MapTypeId.HYBRID);
			break;
		case 'google.maps.MapTypeId.TERRAIN' :
			map.setMapTypeId(google.maps.MapTypeId.TERRAIN);
			break;
	}
	map.setOptions({styles: $ck('#snazzymaps').val()});
	var mapw = $ck('#mapwidth').val() ? $ck('#mapwidth').val() : '';
	var maph = $ck('#mapheight').val() ? $ck('#mapheight').val() : '';
	$ck('#previewareabloc #mapck').css('width', mapw).css('padding-bottom', maph).height('0');
	$ck('.editfocus #mapck').css('width', mapw).css('padding-bottom', maph).height('0');
	ckRefreshMap();
}

function ckRefreshMap() {
	google.maps.event.trigger(map,'resize');
}
</script>