<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckList extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_LIST';

	private $type = 'list';

	function __construct(&$subject, $params) {
		parent::__construct($subject, $params);
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'text';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/list/assets/images/list.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentList() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>">
			<div class="tab_listoptions ckprops" orientation="vertical" nbcols="1" fieldslist="orientation,nbcols"></div>
			<div class="tab_iconstyles ckprops" iconicontype="svg" iconiconsvgsize="16" iconiconsvgfill="#00aaff" iconiconsvgstrokewidth="2" iconmarginright="5" fieldslist="iconicontype,iconiconsvgsize,iconiconsvgstrokewidth,iconiconsvgfill,iconmarginright"></div> 
			<div class="ckstyle">
			<style>
#<?php echo $id; ?> svg * {
	fill: #00aaff;
	stroke-width: 2;
}

#<?php echo $id; ?> svg.svgicon-ionicon *, #ID1669050852334 svg.svgicon-fontawesome * {
	stroke-width: 32;
}
		
#<?php echo $id; ?> svg {
	width: 16px;
	height: 16px;
}
#<?php echo $id; ?> .iconck .pbckicon, #<?php echo $id; ?> .iconck i {
	margin-right: 5px;
}
			</style>
			</div>
			<div class="pbck_list inner">
				<div class="pbck_list_item">
					<span class="iconck"><span class="pbckicon" data-path="fontawesome_solid_check.svg" data-pos="undefined" style="display:inline-block;"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svgicon-fontawesome" style="display: inline-block;"><!-- Font Awesome Free 5.15.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) --><path d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg></span></span>
					<span class="pbck_list_item_text" contenteditable="true">Lorem ipsum</span>
				</div>
				<div class="pbck_list_item">
					<span class="iconck"><span class="pbckicon" data-path="fontawesome_solid_check.svg" data-pos="undefined" style="display:inline-block;"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svgicon-fontawesome" style="display: inline-block;"><!-- Font Awesome Free 5.15.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) --><path d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg></span></span>
					<span class="pbck_list_item_text" contenteditable="true">Lorem ipsum</span>
				</div>
				<div class="pbck_list_item">
					<span class="iconck"><span class="pbckicon" data-path="fontawesome_solid_check.svg" data-pos="undefined" style="display:inline-block;"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svgicon-fontawesome" style="display: inline-block;"><!-- Font Awesome Free 5.15.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) --><path d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg></span></span>
					<span class="pbck_list_item_text" contenteditable="true">Lorem ipsum</span>
				</div>
			</div>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsList() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/list/layouts/edit_list.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemList($item) {
		$html = $item->innertext;

		$listoptions = PagebuilderckFrontHelper::createParamsFromElement($item->find('.tab_listoptions'));
		$styles = '@media only screen and (max-width:' . (int)$listoptions->get('responsiveresolution', '640') . 'px){
					#'.$item->attr['id'].' .pbck_list {
						columns: 1 !important;
					}
				}';
		$doc = JFactory::getDocument();
		$doc->addStyleDeclaration($styles);

		return $html;
	}
}