<?php
/**
 * @name		Page Builder CK
 * @package		com_pagebuilderck
 * @copyright	Copyright (C) 2015. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - https://www.template-creator.com - https://www.joomlack.fr
 */

defined('_JEXEC') or die;
?>
<div id="elementscontainer">
	<div class="menulink" tab="tab_items"><?php echo JText::_('PLG_PAGEBUILDERCK_SOCIAL_ICONS_EDITION'); ?></div>
	<div class="tab menustyles ckproperty tab_fullscreen" id="tab_items">
			<div id="items_edition_list" class="expandable">
			</div>
			<div onclick="ckAddNewListItem()" class="item_add ckbutton ckbutton-primary"><?php echo JText::_('CK_ADD_NEW_ITEM'); ?></div>
			<div class="ckclr"></div>
	</div>
	<div class="menulink" tab="tab_moreoptions"><?php echo JText::_('CK_OPTIONS'); ?></div>
	<div class="tab menustyles ckproperty ckoption" id="tab_moreoptions">
		<div class="ckoption">
			<span class="ckoption-label">
				<img class="ckoption-icon" src="<?php echo $this->imagespath; ?>marginright.png" width="15" height="15" />
				<?php echo JText::_('PLG_PAGEBUILDERCK_SOCIAL_ICONS_SPACING'); ?>
			</span>
			<span class="ckoption-field">
				<input class="inputbox" type="text" name="iconmargin" id="iconmargin" size="2" value="" style="" onchange="ckSetIconsMargin()" />
			</span>
		</div>
		<div class="ckoption">
			<span class="ckoption-label">
				<?php echo JText::_('CK_ALIGN'); ?>
			</span>
			<span class="ckoption-field">
				<span class="ckoption-field ckbutton-group">
					<input id="iconsalignementleft" class="inputbox" name="iconsalignement" value="left" type="radio" onclick="ckSetAlignIcon()">
					<label class="ckbutton" for="iconsalignementleft">
						<img src="<?php echo $this->imagespath; ?>text_align_left.png" width="16" height="16" />
					</label>
					<input id="iconsalignementcenter" class="inputbox" name="iconsalignement" value="center" type="radio" onclick="ckSetAlignIcon()">
					<label class="ckbutton" for="iconsalignementcenter">
						<img src="<?php echo $this->imagespath; ?>text_align_center.png" width="16" height="16" />
					</label>
					<input id="iconsalignementright" class="inputbox" name="iconsalignement" value="right" type="radio" onclick="ckSetAlignIcon()">
					<label class="ckbutton" for="iconsalignementright">
						<img src="<?php echo $this->imagespath; ?>text_align_right.png" width="16" height="16" />
					</label>
				</span>
			</span>
		</div>
	</div>
	<div class="menulink" tab="tab_blocstyles"><?php echo JText::_('CK_STYLES'); ?></div>
	<div class="tab menustyles ckproperty" id="tab_blocstyles">
		<?php echo $this->menustyles->createBlocStyles('bloc', 'social_icons', '') ?>
	</div>
</div>
<script language="javascript" type="text/javascript">
var focus = $ck('.editfocus');
function ckLoadEditionPopup() {

	$ck('.editfocus .pbck_social_icons .pbck_social_icon').each(function(i, el) {
		var iconImgSrc = $ck('img', el).attr('src');
		var iconLinkUrl = $ck(el).attr('href');
		var iconLinkTarget = $ck(el).attr('target');
		var iconText = $ck('.pbck_social_icon_text', el).text();
		var itemInfos = {
			"title" : $ck('.pbck_social_icon_text', el).length ? $ck('.pbck_social_icon_text', el).html() : '',
			"alt" : $ck('img', el).attr('alt') ? $ck('img', el).attr('alt') : '',
			"url_href" : $ck(el).attr('href') ? $ck(el).attr('href') : '',
			"url_target" : $ck(el).attr('target') ? $ck(el).attr('target') : 'default'
			};
		var features = [
			"title",
			"alt",
			"link",
			"link_target"
		];
		var itemedition = ckCreateEditImageItem(i, $ck('#items_edition_list'), '', $ck('img', el), itemInfos, features);
		ckMakeEditItemAccordion(itemedition);
		// $ck('#items_edition_list').append(itemedition);
	});

	ckMakeEditItemsSortable();
	ckFillEditionPopup(focus.attr('id'));
	$ck('.editfocus').css('text-align', $ck('#previewareabloc .pbck_social_icons').attr('data-align'));
}

function ckBeforeSaveEditionPopup() {
	var focus = $ck('.editfocus');

	ckUpdatePreviewArea();

	ckSaveEditionPopup(focus.attr('id'));
	ckCloseEditionPopup();
}

function ckSaveInlineEditionPopup() {
	ckBeforeSaveEditionPopup();
}

function ckBeforeDeleteEditItem(item) {
	var index = item.index('.item_edition');
	$ck('.editfocus .pbck_social_icon').eq(index).remove();
}

function ckUpdatePreviewArea() {
	$ck('#items_edition_list .item_edition').each(function(i, el) {
		var data = ckGetEditImageItem(i, el, focus);
		console.log(data);
		$ck('.editfocus .pbck_social_icon').eq(i).find('img').attr('src', data.attribs.imageurl)
			.attr('alt', data.attribs.imagealt);
		$ck('.editfocus a.pbck_social_icon').eq(i).attr('href', data.attribs.linkhref)
			.attr('target', data.attribs.linktarget)
			.find('.pbck_social_icon_text').text(data.attribs.title)
	});
}

function ckSetAlignIcon() {
	var align = $ck('input[name="iconsalignement"]:checked').val();
	$ck('.editfocus .pbck_social_icons').attr('data-align', align);
	$ck('.editfocus .pbck_social_icons').css('text-align', align);
	$ck('.editfocus .pbck_social_icons').css('justify-content', align);
}

function ckSetIconsMargin() {
	$ck('.editfocus .pbck_social_icon').css('margin-right', $ck('#iconmargin').val()+'px');
	$ck('.editfocus .pbck_social_icon').last().css('margin-right', '0');
}

function ckCreateEditSocialIconItem(i, iconImgSrc, iconLinkUrl, iconLinkTarget, iconText) {
	var itemedition = $ck('<div class="item_edition clearfix" data_index="'+i+'">'
				+'<div class="item_move"></div>'
				+'<div class="item_image">'
				+'<a class="item_image_selection" href="javascript:void(0)" onclick="ckCallImageManagerPopup(\'item_imageurl_'+i+'\')" >'
				+'<img src="'+iconImgSrc+'" />'
				+'</a>'
				+'</div>'
				+'<div class="item_imageurl"><label for="item_imageurl_'+i+'">'+Joomla.JText._('CK_IMAGE_URL','Image url')+'</label><input type="text" id="item_imageurl_'+i+'" name="item_imageurl_'+i+'" class="item_imageurl_edition" value="'+getImgPathFromImgSrc(iconImgSrc)+'" style="width: 400px;" onchange="ckUpdatePreviewArea()"/></div>'
				+'<div class="item_author_url_text"><label for="author_url_text_'+i+'">'+Joomla.JText._('CK_AUTHOR_URL_TEXT','Url text')+'</label><input type="text" id="author_url_text_'+i+'" name="author_url_text_'+i+'" class="item_author_url_text_edition" value="'+iconText+'" style="width: 400px;" onchange="ckUpdatePreviewArea()"/></div>'
				+'<div class="item_author_url_href"><label for="author_url_href_'+i+'">'+Joomla.JText._('CK_AUTHOR_URL_LINK','Url link')+'</label><input type="text" id="author_url_href_'+i+'" name="author_url_href_'+i+'" class="item_author_url_href_edition" value="'+iconLinkUrl+'" style="width: 400px;" onchange="ckUpdatePreviewArea()"/></div>'
				+'<div class="item_author_url_target"><label for="author_url_target_'+i+'">'+Joomla.JText._('CK_AUTHOR_TARGET_LINK','Target link')+'</label><input type="text" id="author_url_target_'+i+'" name="author_url_target_'+i+'" class="item_author_url_target_edition" value="'+iconLinkTarget+'" style="width: 400px;" onchange="ckUpdatePreviewArea()"/></div>'
				+'<br />'
				+'<div class="item_delete btn-small btn btn-danger" onclick="ckDeleteEditItem($ck(this).parent())">'+Joomla.JText._('CK_DELETE','Delete')+'</div>'
				// +'&nbsp;<div class="item_setdefault btn-small btn" onclick="ckSetDefaultEditItem($ck(this).parent())"><span class="icon icon-star"></span>'+Joomla.JText._('CK_SET_DEFAULT','Set as default')+'</div>'
				+'</div>');

	return itemedition;
}


function ckAddNewListItem() {
	// add the element in the social_icons
	var index = $ck('#items_edition_list .item_edition').length;
	var newSocialIconItem = $ck('.editfocus .pbck_social_icon').first().clone();
	$ck('.editfocus .pbck_social_icons').append(newSocialIconItem);
	// add the element for edition
	var newIcon = ckCreateEditSocialIconItem(index, PAGEBUILDERCK.URIROOT+'/plugins/pagebuilderck/social_icons/assets/images/social_icons.png', '', '', '');
	$ck('#items_edition_list').append(newIcon);
	ckUpdatePreviewArea();
}

function ckGetNewSocial_iconsItem(index) {
	var item = '<article class="pbck_testimonial">'
				+'<div class="pbck_testimonial_caption" data-index="'+index+'">'
					+'<div class="pbck_testimonial_title">Lorem Ipsum</div>'
					+'<br />'
					+'<div class="pbck_testimonial_text">Dolor sit amet ...</div>'
				+'</div>'
				+'<img class="pbck_testimonial_img" src="'+PAGEBUILDERCK.URIROOT+'/plugins/pagebuilderck/social_icons/assets/images/images.png"> '
				+'</article>';
	return item;
}

function ckMakeEditItemsSortable() {
	$ck( "#items_edition_list" ).sortable({
		items: ".item_edition",
		helper: "clone",
		handle: ".item_move",
		forcePlaceholderSize: true,
		tolerance: "pointer",
		placeholder: "placeholderck",
		start: function(e, ui){
		},
		stop: function( event, ui ) {
			ckUpdatePreviewArea();
		},
	});
	ckMakeExpandable();
}

</script>
<style type="text/css">
.item_image {
	float: left;
	box-shadow: #888 0 0 10px;
	margin: 0 10px 0 0;
	cursor: pointer;
	border: 5px solid #fff;
}

.item_image:hover {
	border-color: rgba(82, 168, 236, 0.8);
}

.item_image img {
	width: 150px;
	height: 150px;
}

.item_edition .item_toggler {
	display: inline-block;
}

#items_edition_list label {
	display: inline-block;
	width: 180px;
}
</style>