<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckSocial_icons extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_SOCIAL_ICONS';

	private $type = 'social_icons';

	function __construct(&$subject, $params) {
		parent::__construct($subject, $params);
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'other';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/social_icons/assets/images/socialicons.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentSocial_icons() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>">
			<div class="ckstyle">
			</div>
			<div class="pbck_social_icons inner">
				<a class="pbck_social_icon" href="https://www.facebook.com/joomlack" target="_blank">
					<img src="<?php echo JUri::root(true) . '/plugins/pagebuilderck/social_icons/assets/images/facebook.svg'; ?>" />
					<span class="pbck_social_icon_text"></span>
				</a>
				<a class="pbck_social_icon" href="https://twitter.com/ced1870" target="_blank">
					<img src="<?php echo JUri::root(true) . '/plugins/pagebuilderck/social_icons/assets/images/twitter.svg'; ?>" />
					<span class="pbck_social_icon_text"></span>
				</a>
				<a class="pbck_social_icon" href="https://www.instagram.com/" target="_blank">
					<img src="<?php echo JUri::root(true) . '/plugins/pagebuilderck/social_icons/assets/images/instagram.svg'; ?>" />
					<span class="pbck_social_icon_text"></span>
				</a>
			</div>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsSocial_icons() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/social_icons/layouts/edit_social_icons.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemSocial_icons($item) {
		$html = $item->innertext;

		return $html;
	}
}