<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckTable extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_TABLE';

	private $type = 'table';

	protected $table_params;

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	private function callAssets() {
		$doc = JFactory::getDocument();
		PagebuilderckFrontHelper::addStylesheet(JUri::root(true) . '/plugins/pagebuilderck/table/assets/table.css');
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'text';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/table/assets/images/table.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentTable() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>">
			<div class="tab_buttonhoverstyles ckprops" tableckbuttonshoverbackgroundcolorstart="#1353c2" tableckbuttonshoverbackgroundpositionend="100" tableckbuttonshoverbackgrounddirection="topbottom" tableckbuttonshoverbackgroundopacity="50" tableckbuttonshoverbackgroundimageattachment="scroll" tableckbuttonshoverbackgroundimagerepeat="no-repeat" tableckbuttonshoverbackgroundimagesize="auto" tableckbuttonshoverbordertopstyle="solid" tableckbuttonshoverborderrightstyle="solid" tableckbuttonshoverborderbottomstyle="solid" tableckbuttonshoverborderleftstyle="solid" tableckbuttonshoverbordersstyle="solid" tableckbuttonshovershadowopacity="50" tableckbuttonshovershadowinset="0" fieldslist="tableckbuttonshoverbackgroundcolorstart,tableckbuttonshoverbackgroundpositionend,tableckbuttonshoverbackgrounddirection,tableckbuttonshoverbackgroundopacity,tableckbuttonshoverbackgroundimageattachment,tableckbuttonshoverbackgroundimagerepeat,tableckbuttonshoverbackgroundimagesize,tableckbuttonshoveralignementleft,tableckbuttonshoveralignementcenter,tableckbuttonshoveralignementright,tableckbuttonshoveralignementjustify,tableckbuttonshoverbordertopstyle,tableckbuttonshoverborderrightstyle,tableckbuttonshoverborderbottomstyle,tableckbuttonshoverborderleftstyle,tableckbuttonshoverbordersstyle,tableckbuttonshovershadowopacity,tableckbuttonshovershadowinset"></div>
			<div class="tab_buttonstyles ckprops" tableckbuttonsbackgroundcolorstart="#1466ef" tableckbuttonsbackgroundpositionend="100" tableckbuttonsbackgrounddirection="topbottom" tableckbuttonsbackgroundopacity="50" tableckbuttonsbackgroundimageattachment="scroll" tableckbuttonsbackgroundimagerepeat="no-repeat" tableckbuttonsbackgroundimagesize="auto" tableckbuttonscolor="#ffffff" tableckbuttonsalignementcenter="checked" tableckbuttonsfontbold="bold" tableckbuttonsmargins="15" tableckbuttonspaddingtop="8" tableckbuttonspaddingright="20" tableckbuttonspaddingbottom="8" tableckbuttonspaddingleft="20" tableckbuttonsbordertopstyle="solid" tableckbuttonsborderrightstyle="solid" tableckbuttonsborderbottomstyle="solid" tableckbuttonsborderleftstyle="solid" tableckbuttonsbordersstyle="solid" tableckbuttonsborderradius="5" tableckbuttonsshadowopacity="50" tableckbuttonsshadowinset="0" fieldslist="tableckbuttonsbackgroundcolorstart,tableckbuttonsbackgroundpositionend,tableckbuttonsbackgrounddirection,tableckbuttonsbackgroundopacity,tableckbuttonsbackgroundimageattachment,tableckbuttonsbackgroundimagerepeat,tableckbuttonsbackgroundimagesize,tableckbuttonscolor,tableckbuttonsalignementleft,tableckbuttonsalignementcenter,tableckbuttonsalignementright,tableckbuttonsalignementjustify,tableckbuttonsfontbold,tableckbuttonsmargins,tableckbuttonspaddingtop,tableckbuttonspaddingright,tableckbuttonspaddingbottom,tableckbuttonspaddingleft,tableckbuttonsbordertopstyle,tableckbuttonsborderrightstyle,tableckbuttonsborderbottomstyle,tableckbuttonsborderleftstyle,tableckbuttonsbordersstyle,tableckbuttonsborderradius,tableckbuttonsshadowopacity,tableckbuttonsshadowinset"></div>
			<div class="tab_customstyles ckprops" style1backgroundcolorstart="#ededed" style1backgroundpositionend="100" style1backgrounddirection="topbottom" style1backgroundopacity="50" style1backgroundimageattachment="scroll" style1backgroundimagerepeat="no-repeat" style1backgroundimagesize="auto" style1color="#000000" style1fontsize="20" style1alignementcenter="checked" style1fontbold="bold" style1wordspacing="0" style1paddingtop="20" style1paddingbottom="20" style1bordertopstyle="solid" style1borderrightstyle="solid" style1borderbottomstyle="solid" style1borderleftstyle="solid" style1borderssize="0" style1bordersstyle="solid" style1borderradiustopright="5" style1borderradiustopleft="5" style1shadowopacity="50" style1shadowinset="0" style2backgroundpositionend="100" style2backgrounddirection="topbottom" style2backgroundopacity="50" style2backgroundimageattachment="scroll" style2backgroundimagerepeat="no-repeat" style2backgroundimagesize="auto" style2bordertopstyle="solid" style2borderrightsize="0" style2borderrightstyle="solid" style2borderbottomstyle="solid" style2borderleftstyle="solid" style2bordersstyle="solid" style2shadowopacity="50" style2shadowinset="0" style3backgroundpositionend="100" style3backgrounddirection="topbottom" style3backgroundopacity="50" style3backgroundimageattachment="scroll" style3backgroundimagerepeat="no-repeat" style3backgroundimagesize="auto" style3color="#404040" style3fontsize="20" style3alignementcenter="checked" style3fontbold="bold" style3paddingtop="20" style3paddingbottom="20" style3bordertopstyle="solid" style3borderrightstyle="solid" style3borderbottomstyle="solid" style3borderleftstyle="solid" style3bordersstyle="solid" style3shadowopacity="50" style3shadowinset="0" style4backgroundpositionend="100" style4backgrounddirection="topbottom" style4backgroundopacity="50" style4backgroundimageattachment="scroll" style4backgroundimagerepeat="no-repeat" style4backgroundimagesize="auto" style4paddingbottom="5" style4bordertopstyle="solid" style4borderrightstyle="solid" style4borderbottomstyle="solid" style4borderleftstyle="solid" style4borderscolor="#1466ef" style4borderssize="1" style4bordersstyle="solid" style4borderradius="5" style4shadowopacity="50" style4shadowinset="0" fieldslist="style1backgroundcolorstart,style1backgroundpositionend,style1backgrounddirection,style1backgroundopacity,style1backgroundimageattachment,style1backgroundimagerepeat,style1backgroundimagesize,style1color,style1fontsize,style1alignementleft,style1alignementcenter,style1alignementright,style1alignementjustify,style1fontbold,style1wordspacing,style1paddingtop,style1paddingbottom,style1bordertopstyle,style1borderrightstyle,style1borderbottomstyle,style1borderleftstyle,style1borderssize,style1bordersstyle,style1borderradiustopright,style1borderradiustopleft,style1shadowopacity,style1shadowinset,style2backgroundpositionend,style2backgrounddirection,style2backgroundopacity,style2backgroundimageattachment,style2backgroundimagerepeat,style2backgroundimagesize,style2alignementleft,style2alignementcenter,style2alignementright,style2alignementjustify,style2bordertopstyle,style2borderrightsize,style2borderrightstyle,style2borderbottomstyle,style2borderleftstyle,style2bordersstyle,style2shadowopacity,style2shadowinset,style3backgroundpositionend,style3backgrounddirection,style3backgroundopacity,style3backgroundimageattachment,style3backgroundimagerepeat,style3backgroundimagesize,style3color,style3fontsize,style3alignementleft,style3alignementcenter,style3alignementright,style3alignementjustify,style3fontbold,style3paddingtop,style3paddingbottom,style3bordertopstyle,style3borderrightstyle,style3borderbottomstyle,style3borderleftstyle,style3bordersstyle,style3shadowopacity,style3shadowinset,style4backgroundpositionend,style4backgrounddirection,style4backgroundopacity,style4backgroundimageattachment,style4backgroundimagerepeat,style4backgroundimagesize,style4alignementleft,style4alignementcenter,style4alignementright,style4alignementjustify,style4paddingbottom,style4bordertopstyle,style4borderrightstyle,style4borderbottomstyle,style4borderleftstyle,style4borderscolor,style4borderssize,style4bordersstyle,style4borderradius,style4shadowopacity,style4shadowinset"></div>
			<div class="tab_cellstyles ckprops" tableckcellsbackgroundcolorstart="#ffffff" tableckcellsbackgroundpositionend="100" tableckcellsbackgrounddirection="topbottom" tableckcellsbackgroundopacity="50" tableckcellsbackgroundimageattachment="scroll" tableckcellsbackgroundimagerepeat="no-repeat" tableckcellsbackgroundimagesize="auto" tableckcellspaddings="10" tableckcellsbordertopcolor="#ebebeb" tableckcellsbordertopsize="1" tableckcellsbordertopstyle="solid" tableckcellsborderrightstyle="solid" tableckcellsborderbottomstyle="solid" tableckcellsborderleftstyle="solid" tableckcellsbordersstyle="solid" tableckcellsshadowopacity="50" tableckcellsshadowinset="0" fieldslist="tableckcellsbackgroundcolorstart,tableckcellsbackgroundpositionend,tableckcellsbackgrounddirection,tableckcellsbackgroundopacity,tableckcellsbackgroundimageattachment,tableckcellsbackgroundimagerepeat,tableckcellsbackgroundimagesize,tableckcellspaddings,tableckcellsbordertopcolor,tableckcellsbordertopsize,tableckcellsbordertopstyle,tableckcellsborderrightstyle,tableckcellsborderbottomstyle,tableckcellsborderleftstyle,tableckcellsbordersstyle,tableckcellsshadowopacity,tableckcellsshadowinset"></div>
			<div class="tab_colstyles ckprops" tableckcolsbackgroundpositionend="100" tableckcolsbackgrounddirection="topbottom" tableckcolsbackgroundopacity="50" tableckcolsbackgroundimageattachment="scroll" tableckcolsbackgroundimagerepeat="no-repeat" tableckcolsbackgroundimagesize="auto" tableckcolsbordertopstyle="solid" tableckcolsborderrightstyle="solid" tableckcolsborderbottomstyle="solid" tableckcolsborderleftstyle="solid" tableckcolsborderscolor="#dbdbdb" tableckcolsborderssize="1" tableckcolsbordersstyle="solid" tableckcolsborderradius="5" tableckcolsshadowopacity="50" tableckcolsshadowinset="0" fieldslist="tableckcolsbackgroundpositionend,tableckcolsbackgrounddirection,tableckcolsbackgroundopacity,tableckcolsbackgroundimageattachment,tableckcolsbackgroundimagerepeat,tableckcolsbackgroundimagesize,tableckcolsbordertopstyle,tableckcolsborderrightstyle,tableckcolsborderbottomstyle,tableckcolsborderleftstyle,tableckcolsborderscolor,tableckcolsborderssize,tableckcolsbordersstyle,tableckcolsborderradius,tableckcolsshadowopacity,tableckcolsshadowinset"></div>
			<div class="tab_tablestyles ckprops" tableckresponsivevalue="640" tableckbackgroundpositionend="100" tableckbackgrounddirection="topbottom" tableckbackgroundopacity="50" tableckbackgroundimageattachment="scroll" tableckbackgroundimagerepeat="no-repeat" tableckbackgroundimagesize="auto" tableckcolor="#5e5e5e" tableckfontsize="14" tableckalignementcenter="checked" tableckfontfamily="Segoe UI, sans-serif" tableckbordertopstyle="solid" tableckborderrightstyle="solid" tableckborderbottomstyle="solid" tableckborderleftstyle="solid" tableckbordersstyle="solid" tableckborderradius="5" tableckshadowopacity="50" tableckshadowinset="0" fieldslist="tableckresponsivevalue,tableckbackgroundpositionend,tableckbackgrounddirection,tableckbackgroundopacity,tableckbackgroundimageattachment,tableckbackgroundimagerepeat,tableckbackgroundimagesize,tableckcolor,tableckfontsize,tableckalignementleft,tableckalignementcenter,tableckalignementright,tableckalignementjustify,tableckfontfamily,tableckbordertopstyle,tableckborderrightstyle,tableckborderbottomstyle,tableckborderleftstyle,tableckbordersstyle,tableckborderradius,tableckshadowopacity,tableckshadowinset"></div>
			<div class="tab_table ckprops" linktext="Subscribe" fieldslist="linktext"></div>
			<div class="ckstyle">
				<style>
#<?php echo $id; ?> .tableck {
	-moz-border-radius: 5px;
	-o-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px;
	-moz-border-radius: 5px 5px 5px 5px;
	-o-border-radius: 5px 5px 5px 5px;
	-webkit-border-radius: 5px 5px 5px 5px;
	border-radius: 5px 5px 5px 5px;
	color: #5e5e5e;
	text-align: center;
	font-size: 14px;
	font-family: Segoe UI, sans-serif;
}

#<?php echo $id; ?> .tableck .tableck-col {
	border: #dbdbdb 1px solid;
	-moz-border-radius: 5px;
	-o-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px;
	-moz-border-radius: 5px 5px 5px 5px;
	-o-border-radius: 5px 5px 5px 5px;
	-webkit-border-radius: 5px 5px 5px 5px;
	border-radius: 5px 5px 5px 5px;
}

#<?php echo $id; ?> .tableck .tableck-cell {
	background: #ffffff;
	border-top: #ebebeb 1px solid;
	padding: 10px;
}

#<?php echo $id; ?> .tableck .style1 {
	background: #ededed;
	border: none;
	-moz-border-radius: 0px;
	-o-border-radius: 0px;
	-webkit-border-radius: 0px;
	border-radius: 0px;
	-moz-border-radius: 5px 5px 0px 0px;
	-o-border-radius: 5px 5px 0px 0px;
	-webkit-border-radius: 5px 5px 0px 0px;
	border-radius: 5px 5px 0px 0px;
	color: #000000;
	padding-top: 20px;
	padding-bottom: 20px;
	text-align: center;
	font-weight: bold;
	font-size: 20px;
}

#<?php echo $id; ?> .tableck .style2 {
	border-right: none;
}

#<?php echo $id; ?> .tableck .style3 {
	color: #404040;
	padding-top: 20px;
	padding-bottom: 20px;
	text-align: center;
	font-weight: bold;
	font-size: 20px;
}

#<?php echo $id; ?> .tableck .style4 {
	border: #1466ef 1px solid;
	-moz-border-radius: 5px;
	-o-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px;
	-moz-border-radius: 5px 5px 5px 5px;
	-o-border-radius: 5px 5px 5px 5px;
	-webkit-border-radius: 5px 5px 5px 5px;
	border-radius: 5px 5px 5px 5px;
	padding-bottom: 5px;
}

#<?php echo $id; ?> .tableck .tableck-button {
	background: #1466ef;
	-moz-border-radius: 5px;
	-o-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px;
	-moz-border-radius: 5px 5px 5px 5px;
	-o-border-radius: 5px 5px 5px 5px;
	-webkit-border-radius: 5px 5px 5px 5px;
	border-radius: 5px 5px 5px 5px;
	color: #ffffff;
	margin: 15px;
	padding-top: 8px;
	padding-right: 20px;
	padding-bottom: 8px;
	padding-left: 20px;
	text-align: center;
	font-weight: bold;
}

#<?php echo $id; ?> .tableck .tableck-button:hover {
	background: #1353c2;
}
#<?php echo $id; ?> {  }#<?php echo $id; ?>:hover {  }
				</style>
			</div>
			<section class="inner tableck" style="border-spacing: 10px 0px;" >
				<div class="tableck-body">
					<div style="width: 25%;" class="tableck-col">
						<div class="tableck-cell ui-droppable style1" contenteditable="true"><p>Free</p></div>
						<div class="tableck-cell ui-droppable style3" contenteditable="true"><p>Free</p></div><div class="tableck-cell ui-droppable" contenteditable="true"><a onclick="" rel="" href="" class=" tableck-button">Start</a></div><div class="tableck-cell ui-droppable" contenteditable="true"><p>1 GB</p></div>
						<div class="tableck-cell ui-droppable" contenteditable="true"><p>1 User</p></div>
					<div class="tableck-cell ui-droppable" contenteditable="true"><p>Support on forum</p></div></div>
					<div style="width: 25%;" class="tableck-col">
						<div class="tableck-cell ui-droppable style1" contenteditable="true"><p>Beginner</p></div>
						<div class="tableck-cell ui-droppable style3" contenteditable="true"><p>7 €</p></div><div class="tableck-cell ui-droppable" contenteditable="true"><a onclick="" rel="" href="" class=" tableck-button">Subscribe</a></div><div class="tableck-cell ui-droppable" contenteditable="true"><p>3 GB</p></div>
						<div class="tableck-cell ui-droppable" contenteditable="true"><p>5 Users</p></div>
					<div class="tableck-cell ui-droppable" contenteditable="true"><p>Support on forum</p></div></div>
					<div style="width: 25%;" class="tableck-col">
						<div class="tableck-cell ui-droppable style1" contenteditable="true"><p>Advanced</p></div>
						<div class="tableck-cell style3 ui-droppable" contenteditable="true"><p>18 €</p></div><div class="tableck-cell ui-droppable" contenteditable="true"><a onclick="" rel="" href="" class=" tableck-button">Subscribe</a></div><div class="tableck-cell ui-droppable" contenteditable="true"><p>20 GB</p></div>
						<div class="tableck-cell ui-droppable" contenteditable="true"><p>20 Users</p></div>
					<div class="tableck-cell ui-droppable" contenteditable="true"><p>Support tickets</p></div></div>
					<div style="width: 25%;" class="tableck-col">
						<div class="tableck-cell ui-droppable style1" contenteditable="true"><p>Pro</p></div>
						<div class="tableck-cell style3 ui-droppable" contenteditable="true"><p>55 €</p></div><div class="tableck-cell ui-droppable" contenteditable="true"><a onclick="" rel="" href="" class=" tableck-button">Subscribe</a></div><div class="tableck-cell ui-droppable style2" contenteditable="true"><p>Unlimited</p></div>
						<div class="tableck-cell ui-droppable style2" contenteditable="true"><p>Unlimited</p></div>
					<div class="tableck-cell ui-droppable" contenteditable="true"><p>Support tickets</p></div></div>
				
				</div>
			</section>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsTable() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/table/layouts/edit_table.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemTable($item) {
		$this->callAssets();
		$attrs = $item->find('.tab_tablestyles'); // this is the tab id in the interface which contains the options
		$this->table_params = PagebuilderckFrontHelper::createParamsFromElement($attrs);

		$styles = '@media only screen and (max-width:' . (int)$this->table_params->get('tableckresponsivevalue', '640') . 'px){
					#'.$item->attr['id'].' div.tableck-col {
						display: block;
						width: auto !important;
					}
				}';
		PagebuilderckFrontHelper::addStyleDeclaration($styles);
		$html = $item->innertext;

		return $html;
	}
}