<?php
/**
 * @copyright	Copyright (C) 2020 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckTablerow extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_TABLEROW';

	private $type = 'tablerow';

	protected $tablerow_params;

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	private function callAssets() {
		$doc = JFactory::getDocument();
		PagebuilderckFrontHelper::addStylesheet(JUri::root(true) . '/plugins/pagebuilderck/tablerow/assets/tablerow.css');
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'text';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/tablerow/assets/images/tablerow.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentTablerow() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>" customstyles='{"style1":"heading"}'>
			<div class="tab_tablerowstyles ckprops" tablerowckresponsivevalue="524" tableborderscolor="#dddddd" tableborderssize="1" tablebordersstyle="solid" tablerowckbackgroundpositionend="100" tablerowckbackgrounddirection="topbottom" tablerowckbackgroundopacity="50" tablerowckbackgroundimageattachment="scroll" tablerowckbackgroundimagerepeat="no-repeat" tablerowckbackgroundimagesize="auto" tablerowckfontsize="14" tablerowckbordertopstyle="solid" tablerowckborderrightstyle="solid" tablerowckborderbottomstyle="solid" tablerowckborderleftstyle="solid" tablerowckbordersstyle="solid" tablerowckshadowopacity="50" tablerowckshadowinset="0" fieldslist="tablerowckresponsivevalue,tableborderscolor,tableborderssize,tablebordersstyle,tablerowckbackgroundpositionend,tablerowckbackgrounddirection,tablerowckbackgroundopacity,tablerowckbackgroundimageattachment,tablerowckbackgroundimagerepeat,tablerowckbackgroundimagesize,tablerowckfontsize,tablerowckalignementleft,tablerowckalignementcenter,tablerowckalignementright,tablerowckalignementjustify,tablerowckbordertopstyle,tablerowckborderrightstyle,tablerowckborderbottomstyle,tablerowckborderleftstyle,tablerowckbordersstyle,tablerowckshadowopacity,tablerowckshadowinset"></div>
			<div class="tab_cellstyles ckprops" tablerowckcellsbackgroundpositionend="100" tablerowckcellsbackgrounddirection="topbottom" tablerowckcellsbackgroundopacity="50" tablerowckcellsbackgroundimageattachment="scroll" tablerowckcellsbackgroundimagerepeat="no-repeat" tablerowckcellsbackgroundimagesize="auto" tablerowckcellspaddings="16" tablerowckcellsbordertopstyle="solid" tablerowckcellsborderrightstyle="solid" tablerowckcellsborderbottomstyle="solid" tablerowckcellsborderleftstyle="solid" tablerowckcellsbordersstyle="solid" tablerowckcellsshadowopacity="50" tablerowckcellsshadowinset="0" fieldslist="tablerowckcellsbackgroundpositionend,tablerowckcellsbackgrounddirection,tablerowckcellsbackgroundopacity,tablerowckcellsbackgroundimageattachment,tablerowckcellsbackgroundimagerepeat,tablerowckcellsbackgroundimagesize,tablerowckcellspaddings,tablerowckcellsbordertopstyle,tablerowckcellsborderrightstyle,tablerowckcellsborderbottomstyle,tablerowckcellsborderleftstyle,tablerowckcellsbordersstyle,tablerowckcellsshadowopacity,tablerowckcellsshadowinset"></div>
			<div class="tab_customstyles ckprops" style1backgroundcolorstart="#fafafa" style1backgroundpositionend="100" style1backgrounddirection="topbottom" style1backgroundopacity="50" style1backgroundimageattachment="scroll" style1backgroundimagerepeat="no-repeat" style1backgroundimagesize="auto" style1color="#616161" style1fontweight="600" style1bordertopstyle="solid" style1borderrightstyle="solid" style1borderbottomstyle="solid" style1borderleftstyle="solid" style1bordersstyle="solid" style1shadowopacity="50" style1shadowinset="0" fieldslist="style1backgroundcolorstart,style1backgroundpositionend,style1backgrounddirection,style1backgroundopacity,style1backgroundimageattachment,style1backgroundimagerepeat,style1backgroundimagesize,style1color,style1fontweight,style1alignementleft,style1alignementcenter,style1alignementright,style1alignementjustify,style1bordertopstyle,style1borderrightstyle,style1borderbottomstyle,style1borderleftstyle,style1bordersstyle,style1shadowopacity,style1shadowinset"></div>
			<div class="ckstyle">
				<style>
#<?php echo $id; ?> .tablerowck {
	font-size: 14px;
}

#<?php echo $id; ?> .tablerowck .tablerowck-row {
}

#<?php echo $id; ?> .tablerowck .tablerowck-cell {
	padding: 16px;
}

#<?php echo $id; ?> .tablerowck .style1 {
	background: #fafafa;
	background: rgba(250,250,250,0.5);
	-pie-background: rgba(250,250,250,0.5);
	color: #616161;
	font-weight: 600;
}

#<?php echo $id; ?> .tablerowck .tablerowck-button {
	background: #f9f9f9;
	background: rgba(249,249,249,0.5);
	-pie-background: rgba(249,249,249,0.5);
	margin: 5px;
	padding: 6px;
}

#<?php echo $id; ?> .tablerowck .tablerowck-button:hover {
}
#<?php echo $id; ?> {  }#<?php echo $id; ?>:hover {  }#<?php echo $id; ?> table {
  width: 100%;
  max-width: 100%;
  border-collapse: collapse;
  border-spacing: 0;
}
#<?php echo $id; ?> table th,
#<?php echo $id; ?> table td {
  border-top: 1px solid #dddddd;
}

#<?php echo $id; ?> table caption + thead tr:first-child th,
#<?php echo $id; ?> table caption + thead tr:first-child td,
#<?php echo $id; ?> table colgroup + thead tr:first-child th,
#<?php echo $id; ?> table colgroup + thead tr:first-child td,
#<?php echo $id; ?> table thead:first-child tr:first-child th,
#<?php echo $id; ?> table thead:first-child tr:first-child td {
  border-top: 0;
}
#<?php echo $id; ?> table tbody + tbody {
  border-top: 1px solid #dddddd;
}#<?php echo $id; ?> table {
  border: 1px solid #dddddd;
  border-collapse: collapse;
  border-left: 0;
}
#<?php echo $id; ?> table th,
#<?php echo $id; ?> table td {
  border-left: 1px solid #dddddd;
}
#<?php echo $id; ?> table caption + thead tr:first-child th,
#<?php echo $id; ?> table caption + tbody tr:first-child th,
#<?php echo $id; ?> table caption + tbody tr:first-child td,
#<?php echo $id; ?> table colgroup + thead tr:first-child th,
#<?php echo $id; ?> table colgroup + tbody tr:first-child th,
#<?php echo $id; ?> table colgroup + tbody tr:first-child td,
#<?php echo $id; ?> table thead:first-child tr:first-child th,
#<?php echo $id; ?> table tbody:first-child tr:first-child th,
#<?php echo $id; ?> table tbody:first-child tr:first-child td {
  border-top: 0;
}



				</style>
			</div>
			<table class="inner tablerowck">
				<tbody class="tablerowck-body">
					<tr class="tablerowck-row">
						<td class="tablerowck-cell style1"><p>Lorem</p></td>
						<td class="tablerowck-cell style1"><p>Consectetur</p></td>
						<td class="tablerowck-cell style1"><p>Praesent</p></td>
					</tr>
					<tr class="tablerowck-row">
						<td class="tablerowck-cell"><p>Donec</p></td>
						<td class="tablerowck-cell"><p>Placerat</p></td>
						<td class="tablerowck-cell"><p>Quisque</p></td>
					</tr>
					<tr class="tablerowck-row">
						<td class="tablerowck-cell"><p>Curabitur</p></td>
						<td class="tablerowck-cell"><p>Condimentum</p></td>
						<td class="tablerowck-cell"><p>Faucibus</p></td>
					</tr>
				</tbody>
			</table>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsTablerow() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/tablerow/layouts/edit_tablerow.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemTablerow($item) {
		$this->callAssets();
		$attrs = $item->find('.tab_tablerowstyles'); // this is the tab id in the interface which contains the options
		$this->tablerow_params = PagebuilderckFrontHelper::createParamsFromElement($attrs);

		$styles = '@media only screen and (max-width:' . (int)$this->tablerow_params->get('tablerowckresponsivevalue', '640') . 'px){
					#'.$item->attr['id'].' .tablerowck .tablerowck-row,
					#'.$item->attr['id'].' .tablerowck .tablerowck-body {
						display: flex;
						flex-direction: column;
					}
				}';
		PagebuilderckFrontHelper::addStyleDeclaration($styles);
		$html = $item->innertext;

		return $html;
	}
}