<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckTeams extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_TEAMS';

	private $type = 'teams';

	protected $layout_params;

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	public function callAssets() {
		// load the script in the page in admin and front
		JHtml::_('jquery.framework');
		$doc = JFactory::getDocument();
		PagebuilderckFrontHelper::addStylesheet(JUri::root(true) . '/plugins/pagebuilderck/teams/assets/teams.css');
		$doc->addScript(JUri::root(true) . '/plugins/pagebuilderck/teams/assets/teams.js');

	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'other';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/teams/assets/images/teams.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentTeams() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		$this->loadLanguage();
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>">
			<div class="tab_imagestyles ckprops" teamimagebackgroundpositionend="100" teamimagebackgrounddirection="topbottom" teamimagebackgroundimageattachment="scroll" teamimagebackgroundimagerepeat="no-repeat" teamimagebackgroundimagesize="auto" teamimagemarginright="auto" teamimagemarginleft="auto" teamimagebordertopstyle="solid" teamimageborderrightstyle="solid" teamimageborderbottomstyle="solid" teamimageborderleftstyle="solid" teamimageborderscolor="#c2b93c" teamimagebordersstyle="solid" teamimageshadowinset="0" fieldslist="teamimagebackgroundpositionend,teamimagebackgrounddirection,teamimagebackgroundimageattachment,teamimagebackgroundimagerepeat,teamimagebackgroundimagesize,teamimagealignementleft,teamimagealignementcenter,teamimagealignementright,teamimagealignementjustify,teamimagemarginright,teamimagemarginleft,teamimagebordertopstyle,teamimageborderrightstyle,teamimageborderbottomstyle,teamimageborderleftstyle,teamimageborderscolor,teamimagebordersstyle,teamimageshadowinset"></div>
			<div class="tab_statusstyles ckprops" statusbackgroundpositionend="100" statusbackgrounddirection="topbottom" statusbackgroundimageattachment="scroll" statusbackgroundimagerepeat="no-repeat" statusbackgroundimagesize="auto" statuscolor="#c8cccf" statusfontsize="13" statusfontweight="700" statuspaddingbottom="5" statusbordertopstyle="solid" statusborderrightstyle="solid" statusborderbottomstyle="solid" statusborderleftstyle="solid" statusbordersstyle="solid" statusshadowinset="0" fieldslist="statusbackgroundpositionend,statusbackgrounddirection,statusbackgroundimageattachment,statusbackgroundimagerepeat,statusbackgroundimagesize,statuscolor,statusfontsize,statusfontweight,statusalignementleft,statusalignementcenter,statusalignementright,statusalignementjustify,statuspaddingbottom,statusbordertopstyle,statusborderrightstyle,statusborderbottomstyle,statusborderleftstyle,statusbordersstyle,statusshadowinset"></div>
			<div class="tab_namestyles ckprops" namebackgroundpositionend="100" namebackgrounddirection="topbottom" namebackgroundimageattachment="scroll" namebackgroundimagerepeat="no-repeat" namebackgroundimagesize="auto" namecolor="#4d4d4d" namefontsize="16" namefontbold="bold" namelineheight="30" namepaddingtop="10" namebordertopstyle="solid" nameborderrightstyle="solid" nameborderbottomstyle="solid" nameborderleftstyle="solid" namebordersstyle="solid" nameshadowinset="0" fieldslist="namebackgroundpositionend,namebackgrounddirection,namebackgroundimageattachment,namebackgroundimagerepeat,namebackgroundimagesize,namecolor,namefontsize,namealignementleft,namealignementcenter,namealignementright,namealignementjustify,namefontbold,namelineheight,namepaddingtop,namebordertopstyle,nameborderrightstyle,nameborderbottomstyle,nameborderleftstyle,namebordersstyle,nameshadowinset"></div>
			<div class="tab_itemstyles ckprops" itembackgroundcolorstart="#ffffff" itembackgroundpositionend="100" itembackgrounddirection="topbottom" itembackgroundimageattachment="scroll" itembackgroundimagerepeat="no-repeat" itembackgroundimagesize="auto" itemcolor="#424242" itemnormallinkcolor="#ef023f" itemhoverlinkcolor="#9c2f4a" itemmargintop="20" itemmarginbottom="20" itemborderradius="5" itembordertopstyle="solid" itemborderrightstyle="solid" itemborderbottomstyle="solid" itemborderleftstyle="solid" itembordersstyle="solid" itemshadowcolor="#000000" itemshadowopacity="20" itemshadowblur="10" itemshadowoffseth="0" itemshadowoffsetv="5" itemshadowinset="0" fieldslist="itembackgroundcolorstart,itembackgroundpositionend,itembackgrounddirection,itembackgroundimageattachment,itembackgroundimagerepeat,itembackgroundimagesize,itemcolor,itemalignementleft,itemalignementcenter,itemalignementright,itemalignementjustify,itemnormallinkcolor,itemhoverlinkcolor,itemmargintop,itemmarginbottom,itemborderradius,itembordertopstyle,itemborderrightstyle,itemborderbottomstyle,itemborderleftstyle,itembordersstyle,itemshadowcolor,itemshadowopacity,itemshadowblur,itemshadowoffseth,itemshadowoffsetv,itemshadowinset"></div>
			<div class="tab_teamoptions ckprops" spacebetween="20" layoutorder="image,name,status,quote,text,url" layoutstate="1,1,1,0,0,0" fieldslist="spacebetween,layoutorder,layoutstate"></div>
			<div class="tab_blocstyles ckprops" blocbackgroundpositionend="100" blocbackgrounddirection="topbottom" blocbackgroundimageattachment="scroll" blocbackgroundimagerepeat="no-repeat" blocbackgroundimagesize="auto" blocalignementcenter="checked" blocpaddings="20" blocbordertopstyle="solid" blocborderrightstyle="solid" blocborderbottomstyle="solid" blocborderleftstyle="solid" blocbordersstyle="solid" blocshadowinset="0" fieldslist="blocbackgroundpositionend,blocbackgrounddirection,blocbackgroundimageattachment,blocbackgroundimagerepeat,blocbackgroundimagesize,blocalignementleft,blocalignementcenter,blocalignementright,blocalignementjustify,blocpaddings,blocbordertopstyle,blocborderrightstyle,blocborderbottomstyle,blocborderleftstyle,blocbordersstyle,blocshadowinset"></div>
			<div class="ckstyle">
			<style>
#<?php echo $id; ?> .pbck_teams article {
	background: #ffffff;
	-moz-border-radius: 5px;
	-o-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px;
	-moz-border-radius: 5px 5px 5px 5px;
	-o-border-radius: 5px 5px 5px 5px;
	-webkit-border-radius: 5px 5px 5px 5px;
	border-radius: 5px 5px 5px 5px;
	color: #424242;
	margin-top: 20px;
	margin-bottom: 20px;
	box-shadow: rgba(0,0,0,0.2) 0px 5px 10px 0px;
	-moz-box-shadow: rgba(0,0,0,0.2) 0px 5px 10px 0px;
	-webkit-box-shadow: rgba(0,0,0,0.2) 0px 5px 10px 0px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_name {
	color: #4d4d4d;
	padding-top: 10px;
	font-weight: bold;
	line-height: 30px;
	font-size: 16px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_status {
	color: #c8cccf;
	padding-bottom: 5px;
	font-weight: 700;
	font-size: 13px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_quote {
	color: #b3b3b3;
	margin-top: 20px;
	margin-bottom: 20px;
	font-style: italic;
	font-size: 16px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_image img {
	margin-right: auto;
	margin-left: auto;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_readmore .fa {
}

				#<?php echo $id; ?> .pbck_teams .pbck_team_readmore .fa svg * {
			stroke-width: 2;
}
		
				#<?php echo $id; ?> .pbck_teams .pbck_team_readmore .fa svg.svgicon-ionicon *, #<?php echo $id; ?> .pbck_teams .pbck_team_readmore .fa svg.svgicon-fontawesome * {
			stroke-width: 32;
}
		
				#<?php echo $id; ?> .pbck_teams .pbck_team_readmore .fa svg {
			width: 24px;
	height: 24px;
}
		
#<?php echo $id; ?> .pbck_teams .pbck_team_readmore {
	color: #121212;
	margin-bottom: 10px;
	font-size: 13px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_readmore:hover {
}

#<?php echo $id; ?> .pbck_teams .pbck_team_url > a {
	margin-bottom: 10px;
}

#<?php echo $id; ?> .pbck_teams .pbck_team_email > a {
	margin-bottom: 10px;
}

#<?php echo $id; ?> > .inner {
	padding: 20px;
	text-align: center;
}
#<?php echo $id; ?> {  }#<?php echo $id; ?>:hover {  }
		#<?php echo $id; ?> svg * {
	stroke-width: 2;
}

		#<?php echo $id; ?> svg.svgicon-ionicon *, #<?php echo $id; ?> svg.svgicon-fontawesome * {
	stroke-width: 32;
}
		
		#<?php echo $id; ?> svg {
	width: 24px;
	height: 24px;
}

</style>
			</div>
			<div class="pbck_teamer inner" id="<?php echo $id; ?>_pbck_teams">
				<div class="pbck_teams">
					<div class="pbck_wrap">
						<div class="pbck_wrapinner">
							<article class="pbck_team" style="width:calc(100% / 3 - 20px);">
								<div class="pbck_team_image">
									<img src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/teams/assets/images/avatar1.jpg"> 
								</div>
								<div class="pbck_team_name">Julie Foolette</div>
								<div class="pbck_team_status">CEO, Company John</div>
								<div class="pbck_team_quote" data-state="0">Life is wonderful.</div>
								<div class="pbck_team_text" data-state="0">
									<div class="pbck_team_readmore"><span class="iconck"></span><span class="buttontextck"><?php echo JText::_('PLG_PAGEBUILDERCK_TEAMS_READ_MORE') ?></span></div>
									<div class="pbck_team_text_inner">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.</p>
									</div>
								</div>
								<div class="pbck_team_url" data-state="0"><a href="https://www.joomlack.fr">Joomlack</a></div>
							</article>
							<article class="pbck_team" style="width:calc(100% / 3 - 20px);">
								<div class="pbck_team_image">
									<img src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/teams/assets/images/avatar2.jpg"> 
								</div>
								<div class="pbck_team_name">Luca Vondiesel</div>
								<div class="pbck_team_status">Designer, Fooba</div>
								<div class="pbck_team_quote" data-state="0">Life is wonderful.</div>
								<div class="pbck_team_text" data-state="0">
									<div class="pbck_team_readmore"><span class="iconck"></span><span class="buttontextck"><?php echo JText::_('PLG_PAGEBUILDERCK_TEAMS_READ_MORE') ?></span></div>
									<div class="pbck_team_text_inner">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.</p>
									</div>
								</div>
								<div class="pbck_team_url" data-state="0"><a href="https://www.joomlack.fr">Joomlack</a></div>
							</article>
							<article class="pbck_team" style="width:calc(100% / 3 - 20px);">
								<div class="pbck_team_image">
									<img src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/teams/assets/images/avatar3.jpg"> 
								</div>
								<div class="pbck_team_name">Alexia Bigou</div>
								<div class="pbck_team_status">Webmaster</div>
								<div class="pbck_team_quote" data-state="0">Life is wonderful.</div>
								<div class="pbck_team_text" data-state="0">
									<div class="pbck_team_readmore"><span class="iconck"></span><span class="buttontextck"><?php echo JText::_('PLG_PAGEBUILDERCK_TEAMS_READ_MORE') ?></span></div>
									<div class="pbck_team_text_inner">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.</p>
									</div>
								</div>
								<div class="pbck_team_url" data-state="0"><a href="https://www.joomlack.fr">Joomlack</a></div>
							</article>
						</div>
					</div>
				</div>
			</div>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsTeams() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/teams/layouts/edit_teams.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemTeams($item) {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		$layout_attrs = $item->find('.tab_teamoptions'); // this is the tab id in the interface which contains the map options
		$this->layout_params = PagebuilderckFrontHelper::createParamsFromElement($layout_attrs);
		$styles = '@media only screen and (max-width:' . (int)$this->layout_params->get('responsiveresolution', '640') . 'px){
					#'.$item->attr['id'].' div.pbck_teams .pbck_wrapinner {
						display: block;
					}

					#'.$item->attr['id'].' div.pbck_teams .pbck_team {
						width: auto !important;
					}
				}';
		PagebuilderckFrontHelper::addStyleDeclaration($styles);
		// remove disabled elements
		$html = $item->innertext;
		$regex = "#<div\s[^>]*data-state=\"0([^\"]*)\"[^>]*>[^<]*<\/div>#siU"; // replace all divs with state 0
		$html = preg_replace($regex, '', $html);

		$regex = "#<div\s[^>]*class=\"pbck_team_readmore([^\"]*)\"[^>]*>[^<]*<\/div>#siU"; // replace all divs with state 0
		$html = preg_replace($regex, '<div class="pbck_team_readmore">' . JText::_('PLG_PAGEBUILDERCK_TEAMS_READ_MORE') . '</div>', $html);

		return $html;
	}
}