<?php
/**
 * @copyright	Copyright (C) 2015 Cédric KEIFLIN alias ced1870
 * https://www.template-creator.com
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgPagebuilderckTestimonials extends JPlugin {

	private $context = 'PLG_PAGEBUILDERCK_TESTIMONIALS';

	private $type = 'testimonials';

	function __construct(&$subject, $params) {

		parent::__construct($subject, $params);
	}

	private function callAssets() {
		// load the script in the page in admin and front
		JHtml::_('jquery.framework', true);
		$doc = JFactory::getDocument();
		PagebuilderckFrontHelper::addStylesheet(JUri::root(true) . '/plugins/pagebuilderck/testimonials/assets/testimonials.css');
		$doc->addScript(JUri::root(true) . '/plugins/pagebuilderck/testimonials/assets/testimonials.js');

		JText::script('PLG_PAGEBUILDERCK_TESTIMONIALS_AUTHOR_TARGET_LINK_DESC');
	}

	/* 
	 * Construct the Menu Item to drag into the interface
	 *
	 * Return Object with item data
	 */
	public function onPagebuilderckAddItemToMenu() {
		$this->callAssets();
		// load the language files of the plugin
		$this->loadLanguage();
		// create the menu item
		$menuitem = new stdClass();
		$menuitem->type = $this->type;
		$menuitem->group = 'other';
		$menuitem->title = JText::_($this->context . '_MENUITEM_TITLE');
		$menuitem->description = JText::_($this->context . '_MENUITEM_DESC');
		$menuitem->image = JUri::root(true) . '/plugins/pagebuilderck/testimonials/assets/images/testimonials.svg';

		return $menuitem;
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemContentTestimonials() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('ckid', '', 'string');
		// ckstyle and inner classes are needed to get the styles from the interface
		?>
		<div id="<?php echo $id; ?>" class="cktype" data-type="<?php echo $this->type ?>" onshow="pbck_testimonials_init(jQuery(this).attr('id'));">
			<div class="ckstyle">
			</div>
			<div class="pbck_testimonier inner" id="<?php echo $id; ?>_pbck_testimonials">
				<div class="pbck_testimonials">
					<div class="pbck_wrap">
						<div class="pbck_wrapinner">
							<article class="pbck_testimonial current">
								<div class="pbck_testimonial_text">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.
								</div>
								<div class="pbck_testimonial_author">
									<div class="pbck_testimonial_author_inner">
										<div class="pbck_testimonial_author_avatar">
											<img class="pbck_testimonial_img" src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/testimonials/assets/images/avatar1.png"> 
										</div>
										<div class="pbck_testimonial_author_infos">
											<div class="pbck_testimonial_author_name">Luca Vondiesel</div>
											<div class="pbck_testimonial_author_status">CEO, Company John</div>
											<div class="pbck_testimonial_author_url"><a href="https://www.joomlack.fr">Joomlack</a></div>
										</div>
									</div>
								</div>
							</article>
							<article class="pbck_testimonial">
								<div class="pbck_testimonial_text">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.
								</div>
								<div class="pbck_testimonial_author">
									<div class="pbck_testimonial_author_inner">
										<div class="pbck_testimonial_author_avatar">
											<img class="pbck_testimonial_img" src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/testimonials/assets/images/avatar2.png"> 
										</div>
										<div class="pbck_testimonial_author_infos">
											<div class="pbck_testimonial_author_name">Julie Foolette</div>
											<div class="pbck_testimonial_author_status">Designer, Fooba Corporation</div>
											<div class="pbck_testimonial_author_url"><a href="https://www.joomlack.fr">Joomlack</a>
											</div>
										</div>
									</div>
								</div>
							</article>
							<article class="pbck_testimonial">
								<div class="pbck_testimonial_text">
									<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Perspiciatis quia quas, quis illo adipisci voluptate ex harum iste commodi nulla dolor.
								</div>
								<div class="pbck_testimonial_author">
									<div class="pbck_testimonial_author_inner">
										<div class="pbck_testimonial_author_avatar">
											<img class="pbck_testimonial_img" src="<?php echo JUri::root(true); ?>/plugins/pagebuilderck/testimonials/assets/images/avatar3.png"> 
										</div>
										<div class="pbck_testimonial_author_infos">
											<div class="pbck_testimonial_author_name">Alex Bigou</div>
											<div class="pbck_testimonial_author_status">Webmaster</div>
											<div class="pbck_testimonial_author_url"><a href="https://www.joomlack.fr">Joomlack</a></div>
										</div>
									</div>
								</div>
							</article>
						</div>
					</div>
				</div>
				<div class="pbck_testimonials_controls">
					<div onclick="pbck_testimonials_show(this)" class="pbck_testimonials_control control_next"></div>
					<div onclick="pbck_testimonials_show(this)" class="pbck_testimonials_control control_prev"></div>
				</div>
			</div>
		</div>
		<?php
	}

	/* 
	 * Display the html code for the item to be used into the interface
	 *
	 * Return String the html code
	 */
	public function onPagebuilderckLoadItemOptionsTestimonials() {
		// load the language files of the plugin
		$this->loadLanguage();
		// load the interface for the options
		$tpl = JPATH_SITE . '/plugins/pagebuilderck/testimonials/layouts/edit_testimonials.php';
		return $tpl;
	}

	/* 
	 * Display the html code for the item to be used into the frontend page
	 * @param string the item object from simple_html_dom
	 * 
	 * Return String the html code
	 */
	public function onPagebuilderckRenderItemTestimonials($item) {
		$this->callAssets();
		$html = $item->innertext;

		return $html;
	}
}